package sun.awt.shell;

import java.util.concurrent.Callable;
import java.io.FileNotFoundException;
import java.io.File;

class ShellFolderManager
{
    ShellFolderManager() {
    }
    
    public ShellFolder createShellFolder(File file) throws FileNotFoundException {
        return new DefaultShellFolder(null, file);
    }
    
    public Object get(String s) {
        if (s.equals("fileChooserDefaultFolder")) {
            File file = new File(System.getProperty("user.home"));
            try {
                return this.createShellFolder(file);
            }
            catch (FileNotFoundException ex) {
                return file;
            }
        }
        else {
            if (s.equals("roots")) {
                return File.listRoots();
            }
            if (s.equals("fileChooserComboBoxFolders")) {
                return this.get("roots");
            }
            if (s.equals("fileChooserShortcutPanelFolders")) {
                return new File[] { (File)this.get("fileChooserDefaultFolder") };
            }
            return null;
        }
    }
    
    public boolean isComputerNode(File file) {
        return false;
    }
    
    public boolean isFileSystemRoot(File file) {
        return (!(file instanceof ShellFolder) || ((ShellFolder)file).isFileSystem()) && file.getParentFile() == null;
    }
    
    protected ShellFolder.Invoker createInvoker() {
        return new ShellFolderManager.DirectInvoker();
    }
    
    private static class DirectInvoker implements ShellFolder.Invoker
    {
        @Override
        public <T> T invoke(Callable<T> callable) throws Exception {
            return callable.call();
        }
    }
}
